/********************************************************
 Name          : gpio_int.c
 Author        : adp@unipi.gr
 Copyright     : 
 Description   : ---LED3  , 
 		     	 ---PB0   
 		     	      LED4 
 **********************************************************/
#include "compiler.h"
#include "intc.h"
#include "gpio.h"
#include "board.h"

#if __GNUC__
	__attribute__((__interrupt__))
#elif __ICCAVR32__
__interrupt
#endif

static void PB0_int_handler(void)
	{		
		if (gpio_get_pin_value(GPIO_PUSH_BUTTON_0) == 1)
			gpio_set_gpio_pin(LED3_GPIO);
		else
			gpio_clr_gpio_pin(LED3_GPIO);	
		gpio_clear_pin_interrupt_flag(GPIO_PUSH_BUTTON_0);
	}
	
//  	
int main(void)
	{
	U32 i,r;
	
	//    
	Disable_global_interrupt();
	//   (  " "
	INTC_init_interrupts();
	//      PB0
	gpio_enable_pin_glitch_filter(GPIO_PUSH_BUTTON_0);
	//      PB0
	gpio_enable_pin_interrupt (GPIO_PUSH_BUTTON_0,GPIO_PIN_CHANGE);
	//     
	INTC_register_interrupt(&PB0_int_handler,AVR32_GPIO_IRQ_11, AVR32_INTC_INT0);
	//    
	Enable_global_interrupt();

	while (1) //  
	{
	//   
    for (i = 0; i < 1000; i += 1) 
    	r=rand();  
    //   (toggle) LED2
	gpio_tgl_gpio_pin(LED2_GPIO);
  }
}
